/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: net_rename.h,v 1.2 2004/09/07 00:49:31 abe Exp abe $
 */

#ifndef _NET_RENAME_H_
#define _NET_RENAME_H_

/*
 *  ѥͥåȥ󥿥ե̾Υ͡
 */

/* net/ethernet.c */

#define ether_broad_cast_addr	_tinet_ether_broad_cast_addr
#define ether_ipv4_addr_local	_tinet_ether_ipv4_addr_local
#define ether_ipv4_addr_local_mask	\
				_tinet_ether_ipv4_addr_local_mask

#define	ether_raw_output	_tinet_ether_raw_output
#define ether_output		_tinet_ether_output
#define ether_in6_ifaddr	_tinet_ether_in6_ifaddr
#define ether_in6_ifaddr_list	_tinet_ether_in6_ifaddr_list
#define ether_in6_resolve_multicast	\
				_tinet_ether_in6_resolve_multicast
#define ether_input_task	_tinet_ether_input_task
#define ether_get_ifnet		_tinet_ether_get_ifnet
#define ether_output_task	_tinet_ether_output_task

/* net/if.c */

#ifdef SUPPORT_ETHER

#define ifinit			_tinet_ifinit
#define if_addmulti		_tinet_if_addmulti

#endif	/* of #ifdef SUPPORT_ETHER */

/* net/net_buf.c */

#define tget_net_buf		_tinet_tget_net_buf
#define rel_net_buf		_tinet_rel_net_buf
#define nbuf_get_tbl		_tinet_nbuf_get_tbl
#define nbuf_get_tbl_size	_tinet_nbuf_get_tbl_size

/* net/net_subr.c */

#define convert_hexdigit	_tinet_convert_hexdigit
#define rev_memcpy_word		_tinet_rev_memcpy_word
#define rev_memcmp_word		_tinet_rev_memcmp_word

/* net/net_timer.c */

#define timeout			_tinet_timeout
#define untimeout		_tinet_untimeout
#define busy_callout		_tinet_busy_callout
#define max_busy		_tinet_max_busy

/* route_cfg.c */

#define routing_tbl		_tinet_routing_tbl

#ifdef SUPPORT_PPP

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_LOOP

#endif	/* of #ifdef SUPPORT_LOOP */

#endif	/* of #ifndef _NET_RENAME_H_ */
