/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: net_buf.h,v 1.2 2004/09/07 00:49:31 abe Exp abe $
 */

#ifndef _NET_BUF_H_
#define _NET_BUF_H_

#define NET_BUF_IX_IF_PDU	0

/*
 *  ͥåȥХåե
 *
 *    4 ƥåȤǥ饤󤹤ɬפΤץåθơ
 *    IF إå 4 ƥåȶǤʤξ硢
 *    IP إåʹߤ 4 ƥåȶĴ롣
 */

#ifndef CPU_NET_ALIGN
#error "CPU_NET_ALIGN expected."
#endif	/* of #ifndef CPU_NET_ALIGN */

/*
 *  ƥץ졼
 */

struct t_net_buf {
	UB	idix;			/* mpfid Υǥå	*/
	UB	unit;			/* 󥿥եֹ	*/
	UH	len;			/* ǡĹ		*/
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	UB	align[4 - IF_HDR_ALIGN];
#endif	/* of #if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4 */
	UB	buf[0];			/* Хåե		*/
	};

#ifndef T_NET_BUF_DEFINED

typedef struct t_net_buf T_NET_BUF;

#define T_NET_BUF_DEFINED

#endif	/* of #ifndef T_NET_BUF_DEFINED */

/*
 *  32 ƥå
 */

typedef struct t_net_buf_32 {
	UB	idix;			/* mpfid Υǥå	*/
	UB	unit;			/* 󥿥եֹ	*/
	UH	len;			/* ǡĹ		*/
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	UB	align[4 - IF_HDR_ALIGN];
#endif
	UB	buf[32];		/* Хåե		*/
	} T_NET_BUF_32;

/*
 *  64 ƥå
 */

typedef struct t_net_buf_64 {
	UB	idix;			/* mpfid Υǥå	*/
	UB	unit;			/* 󥿥եֹ	*/
	UH	len;			/* ǡĹ		*/
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	UB	align[4 - IF_HDR_ALIGN];
#endif
	UB	buf[64];		/* Хåե		*/
	} T_NET_BUF_64;

/*
 *  128 ƥå
 */

typedef struct t_net_buf_128 {
	UB	idix;			/* mpfid Υǥå	*/
	UB	unit;			/* 󥿥եֹ	*/
	UH	len;			/* ǡĹ		*/
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	UB	align[4 - IF_HDR_ALIGN];
#endif
	UB	buf[128];		/* Хåե		*/
	} T_NET_BUF_128;

/*
 *  256 ƥå
 */

typedef struct t_net_buf_256 {
	UB	idix;			/* mpfid Υǥå	*/
	UB	unit;			/* 󥿥եֹ	*/
	UH	len;			/* ǡĹ		*/
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	UB	align[4 - IF_HDR_ALIGN];
#endif
	UB	buf[256];		/* Хåե		*/
	} T_NET_BUF_256;

/*
 *  512 ƥå
 */

typedef struct t_net_buf_512 {
	UB	idix;			/* mpfid Υǥå	*/
	UB	unit;			/* 󥿥եֹ	*/
	UH	len;			/* ǡĹ		*/
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	UB	align[4 - IF_HDR_ALIGN];
#endif
	UB	buf[512];		/* Хåե		*/
	} T_NET_BUF_512;

/*
 *  1024 ƥå
 */

typedef struct t_net_buf_1024 {
	UB	idix;			/* mpfid Υǥå	*/
	UB	unit;			/* 󥿥եֹ	*/
	UH	len;			/* ǡĹ		*/
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	UB	align[4 - IF_HDR_ALIGN];
#endif
	UB	buf[1024];		/* Хåե		*/
	} T_NET_BUF_1024;

/*
 *  IF_PDU
 */

typedef struct t_net_buf_if_pdu {
	UB	idix;			/* mpfid Υǥå	*/
	UB	unit;			/* 󥿥եֹ	*/
	UH	len;			/* ǡĹ		*/
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	UB	align[4 - IF_HDR_ALIGN];
#endif
	UB	buf[IF_PDU_SIZE];	/* Хåե		*/
	} T_NET_BUF_IF_PDU;

#ifdef IP4_CFG_FRAGMENT

/*
 *  4096 ƥå
 */

typedef struct t_net_buf_4096 {
	UB	idix;			/* mpfid Υǥå	*/
	UB	unit;			/* 󥿥եֹ	*/
	UH	len;			/* ǡĹ		*/
#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
	UB	align[4 - IF_HDR_ALIGN];
#endif
	UB	buf[4096];		/* Хåե		*/
	} T_NET_BUF_4096;

#define MAX_NET_BUF_SIZE	4096

#else	/* of #ifdef IP4_CFG_FRAGMENT */

#define MAX_NET_BUF_SIZE	IF_PDU_SIZE

#endif	/* of #ifdef IP4_CFG_FRAGMENT */

/*
 *  
 */

#define MIN_NET_BUF_SIZE	128

/*
 *  ͥåȥХåեɽ
 */

typedef struct t_net_buf_entry {

	UH	index;
	UH	size;

#if NET_COUNT_ENABLE & PROTO_FLG_NET_BUF

	UW	requests;
	UW	allocs;
	UW	errors;
	UW	busy;

#endif	/* of #if NET_COUNT_ENABLE & PROTO_FLG_NET_BUF */

	} T_NET_BUF_ENTRY;

/*
 *  ؿߥ졼ޥ
 */

#define get_net_buf(b,l)	tget_net_buf((b),(l),TMO_FEVR)

/*
 *  ؿ
 */

extern ER tget_net_buf (T_NET_BUF **blk, UH len, TMO tmout);
extern ER rel_net_buf (T_NET_BUF *blk);
extern const T_NET_BUF_ENTRY *nbuf_get_tbl (void);
extern int nbuf_get_tbl_size (void);

#endif	/* of #ifndef _NET_BUF_H_ */
