/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: in_rename.h,v 1.2 2004/09/07 00:50:05 abe Exp abe $
 */

#ifndef _IN_RENAME_H_
#define _IN_RENAME_H_

/*
 *  TCP/IP ץȥ륹å̾Υ͡
 */

/* netinet/tcp_subr.c */

#define tcp_initialized		_tinet_tcp_initialized

#define tcp_init		_tinet_tcp_init
#define tcp_init_iss		_tinet_tcp_init_iss
#define tcp_close		_tinet_tcp_close
#define tcp_drop		_tinet_tcp_drop
#define tcp_respond		_tinet_tcp_respond
#define	tcp_get_segment		_tinet_tcp_get_segment
#define tcp_sbuf_drop		_tinet_tcp_sbuf_drop
#define tcp_rbuf_append		_tinet_tcp_rbuf_append
#define tcp_seg_fill		_tinet_tcp_seg_fill
#define tcp_rexmt_val		_tinet_tcp_rexmt_val
#define tcp_init_cep		_tinet_tcp_init_cep
#define tcp_notify		_tinet_tcp_notify
#define tcp_find_cep		_tinet_tcp_find_cep
#define tcp_remove_cep		_tinet_tcp_remove_cep
#define tcp_attach_cep		_tinet_tcp_attach_cep
#define tcp_free_all_queue	_tinet_tcp_free_all_queue
#define tcp_alloc_auto_port	_tinet_tcp_alloc_auto_port
#define tcp_alloc_port		_tinet_tcp_alloc_port

/* netinet/tcp_input.c */

#define tcp_iss			_tinet_tcp_iss

#define tcp_input		_tinet_tcp_input

/* netinet/tcp_timer.c */

#define	tcp_cancel_timers	_tinet_tcp_cancel_timers
#define tcp_slow_timo		_tinet_tcp_slow_timo
#define tcp_fast_timo		_tinet_tcp_fast_timo
#define tcp_range_set		_tinet_tcp_range_set
#define tcp_set_persist_timer	_tinet_tcp_set_persist_timer

/* netinet/tcp_output.c */

#define tcp_output		_tinet_tcp_output

/* tcp_cfg.c */

#define tcp_crep		_tinet_tcp_crep
#define tcp_ccep		_tinet_tcp_ccep
#define tmax_tcp_crepid		_tinet_tmax_tcp_crepid
#define tmax_tcp_ccepid		_tinet_tmax_tcp_ccepid

/* netinet/udp_input.c */

#define udp_input		_tinet_udp_input

/* udp_cfg.c */

#define udp_ccep		_tinet_udp_ccep
#define tmax_udp_ccepid		_tinet_tmax_udp_ccepid

/* netinet/ip_icmp.c */

#define icmp_input		_tinet_icmp_input
#define icmp_error		_tinet_icmp_error
#define icmp_echo_reply		_tinet_icmp_echo_reply

/* netinet/ip_input.c */

#define ip_input		_tinet_ip_input
#define ip_init			_tinet_ip_init
#define ip_remove_options	_tinet_ip_remove_options

/* netinet/ip_output.c */

#define ip_output		_tinet_ip_output

/* netinet/in_subr.c */

#define in4_get_datagram	_tinet_in4_get_datagram
#define in4_cksum		_tinet_in4_cksum
#define in4_rtalloc		_tinet_in4_rtalloc
#define in4_rtredirect		_tinet_in4_rtredirect
#define in4_init		_tinet_in4_init
#define in4_is_dstaddr_accept	_tinet_in4_is_dstaddr_accept
#define in_cksum		_tinet_in_cksum
#define in_cksum_carry		_tinet_in_cksum_carry
#define in_cksum_sum		_tinet_in_cksum_sum
#define in_rtnewentry		_tinet_in_rtnewentry
#define in_rtinit		_tinet_in_rtinit
#define in_rttimer		_tinet_in_rttimer

/* netinet/if_ether.c */

#define arp_input		_tinet_arp_input
#define arp_resolve		_tinet_arp_resolve
#define arp_init		_tinet_arp_init
#define arp_get_cache		_tinet_arp_get_cache

/* netinet6/icmp6.c */

#define icmp6_input		_tinet_icmp6_input

#endif	/* of #ifndef _IN_RENAME_H_ */
